#include "gametoy.h"
#ifndef _MSC_VER

///////////////////////////////////////////////////////////////////////////////
// MAIN
///////////////////////////////////////////////////////////////////////////////

extern unsigned short adder[];
extern short volume[];

extern void mainloop();

int main(void)
{		

	// setup hw

	// main timer (8khz)
	TCCR1B = _BV(WGM12) | _BV(CS10); // clear timer on compare match, prescale 1x
	// Hopefully the timer can be pumped back up to 15.6kHz when mixer is in Assembler..
	OCR1A = F_CPU / 7812;// / 15625; nkHz timer
	TIMSK = _BV(OCIE1A); // output compare 1 overflor interrupt enable

	// DAC timer - 8bit fast pwm, pin PORTB 3 output through OCR0
	TCCR0 = _BV(CS00) | _BV(WGM00) | _BV(WGM01) | _BV(COM01);// | _BV(COM00);
	
	sei(); // enable interrupts

	DDRB = 0xff; // debug leds
	
	DDRD = 0;
	PORTD = 0xff;

	lcd_init();

	while (1)
	{		
		PORTB &= ~1;
		PORTB |= (tick >> 10) & 1;


		mainloop();

		lcd_dump();
	}

	return 0;

}
#endif // _MSC_VER
